close all;
addpath('../'); %add matlab function to solve the problem

%% global constants
global R_CONST; %reprojection error weight
global S_CONST; %smoothness error weight
global M1_CONST; %length preservation on lower edge weight
global M2_CONST; %length preservation on upper length weight
global M3_CONST; %width preservation weight
global P_IMAGE;  %image with deformed paper

%%load images
load('data.mat');
T = imread('template.jpg');
I = imread('pic 004small.jpg');
P_IMAGE = I; %global reference for display functions. Used for performance reason

%PROBLEM PARAMETERS...................................................
NUM_VER = 7;    %number of vertices for the triangles
IMG_LENGTH = 1056;  % length of the template image in pixels
IMG_WIDTH = 1600;   % width of the template image in pixels
K1  = [ 1.2108461125383883e+003, 0, 447.8686668343668800; 0, ...
       1.2089178302996092e+003, 329.5778067373487900; 0, 0, 1 ]; 
S = [K1, [0 0 0]']; %camera calibration matrix

tPoints=tPoints';
tPoints=[tPoints ones(size(tPoints, 1), 1)];    %homogeneous 2D coordinates of the points on the template
iPoints=iPoints';
iPoints=[iPoints ones(size(iPoints, 1), 1)];    %homogeneous 2D coordinates of the same points on the image with the deformed paper

dataStruct = struct ('S', S, 'tPoints', tPoints, 'iPoints', iPoints, 'W', IMG_LENGTH, 'H', IMG_WIDTH, 'nver', NUM_VER);

%%
close all;
R_CONST=1e0; %reprojection error weight
S_CONST=1e0; %smoothness error weight
M1_CONST=1e0; %length preservation on lower edge weight
M2_CONST=1e0; %length preservation on upper length weight
M3_CONST=1e0; %width preservation weight

v=performOptimization(dataStruct);

