% PLOTSOLUTION plots the 3-D broken line that contains the vertices of the
% triangles used to locate points i the image
% input argument x is the argument of the minimization
% input argument state is the minimization state
%
% created on 2008/08/24 by Pamela Gotti - pamela.gotti@gmail.com

function stop = plotSolution(x,optimValues,state)
stop = false;

%graphs handles
plotBrokenLine = findobj(get(gca,'Children'),'Tag','plotBrokenLine');
plotPoints = findobj(get(gca,'Children'),'Tag','plotPoints');


aPoints=reshape(x, numel(x)/3, 3);  %broken line
aPoints=[aPoints;aPoints(end-1:-2:1,:);aPoints(((1*mod(size(aPoints,1),2)==0)+1):2:end,:)]; %adding other point to aPoints vector to plot the rectangle contour too

switch state
    case 'init'
        % nothing to do
    case 'iter'
        if optimValues.iteration == 0
            % The 'iter' case is  called during the zeroth iteration,
            % but it has values that were empty during the 'init' case
            hold off;
            plotBrokenLine = plot3(aPoints(:,1), aPoints(:,2), aPoints(:,3));   % plots the broken line
            axis equal;
            grid on;
            hold on;
            title('3D approximation of the paper structure');
            xLabel('x');
            yLabel('y');
            zLabel('z');
            set(plotBrokenLine,'Tag','plotBrokenLine');
        else
            % Not the zeroth iteration
            set(plotBrokenLine,'Xdata',aPoints(:,1), 'Ydata', aPoints(:,2), 'Zdata', aPoints(:,3));
        end
end

